> For the complete documentation index, see [llms.txt](https://docs.carto.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.carto.com/carto-for-developers/key-concepts/carto-for-deck.gl/basemaps/carto-google-maps/readme-1/advanced-examples/extrusion.md).

# Extrusion

This example shows how to **apply extrusion to a layer for generating 3D visualizations**.

{% tabs %}
{% tab title="CARTO 3" %}
{% embed url="<https://codesandbox.io/embed/carto-google-maps-examples-w2puou?fontsize=14&hidenavigation=1&initialpath=%2Fadvanced-examples%2Fextrusion.html&module=%2Fadvanced-examples%2Fextrusion.html>" %}

```html
<!DOCTYPE html>
<html>
  <head>
    <title>Extrusion</title>
    <script src="https://polyfill.io/v3/polyfill.min.js?features=default"></script>
    <script src="https://unpkg.com/deck.gl@^8.8.0/dist.min.js"></script>
    <script src="https://unpkg.com/@deck.gl/carto@^8.8.0/dist.min.js"></script>
    <style>
      #map {
        height: 100%;
      }

      html,
      body {
        height: 100%;
        margin: 0;
        padding: 0;
      }
    </style>
  </head>

  <body>
    
    <div id="map"></div>

    <script  
      src="https://maps.googleapis.com/maps/api/js?key=AIzaSyDvHtBZM79O5uGTBT1ZOWOKW2_FVMstHNs&callback=initMap&libraries=&v=beta"
      async
    ></script>

  </body>

  <script type="text/javascript">
    let map;

    function initMap() {
      map = new google.maps.Map(document.getElementById("map"), {
        center: { lat: 40.7368521, lng: -73.9936065 },
        zoom: 12,
        tilt: 70,
        mapId: '74fb72d0338f9316',
        fullscreenControl: false,
        streetViewControl: false,
        zoomControlOptions: {
          position: google.maps.ControlPosition.LEFT_BOTTOM,
        },
      });

      deck.carto.setDefaultCredentials({
        apiBaseUrl: 'https://gcp-us-east1.api.carto.com',
        apiVersion: deck.carto.API_VERSIONS.V3,
        accessToken: 'eyJhbGciOiJIUzI1NiJ9.eyJhIjoiYWNfbHFlM3p3Z3UiLCJqdGkiOiI1YjI0OWE2ZCJ9.Y7zB30NJFzq5fPv8W5nkoH5lPXFWQP0uywDtqUg8y8c'
      });

      const POLYGON_COLORS = [
        [128, 0, 32],
        [190, 1, 31],
        [255, 77, 32],
        [255, 142, 54],
        [255, 179, 66],
        [254, 239, 157],
        [253, 255, 208],
      ];

      const deckOverlay = new deck.GoogleMapsOverlay({
        layers: [
          new deck.carto.CartoLayer({
            id: 'mrli',
            connection: 'bqconn',
            type: deck.carto.MAP_TYPES.QUERY,
            data: `SELECT geom, index FROM cartobq.public_account.mrli_ny_jan`,
            getFillColor: deck.carto.colorBins({
              attr: 'index',
              domain: [0, 50, 150, 300, 600, 1000],
              colors: POLYGON_COLORS
            }),
            getLineColor: [0, 0, 0, 0],
            lineWidthMinPixels: 0,
            filled: true,
            extruded: true,
            wireframe: true,
            getElevation: (f) => {
              return f.properties.index ? f.properties.index : 0
            }
          }),
        ]
      });

      deckOverlay.setMap(map);
    }

  </script>
</html>
```

{% endtab %}

{% tab title="CARTO 2" %}
{% embed url="<https://codesandbox.io/embed/carto-google-maps-examples-w2puou?fontsize=14&hidenavigation=1carto2&initialpath=%2Fadvanced-examples%2fextrusion-carto2.html&module=%2Fadvanced-examples%2fextrusion-carto2.html>" %}

```html
<!DOCTYPE html>
<html>
  <head>
    <title>Extrusion</title>
    <script src="https://polyfill.io/v3/polyfill.min.js?features=default"></script>
    <script src="https://unpkg.com/deck.gl@^8.8.0/dist.min.js"></script>
    <script src="https://unpkg.com/@deck.gl/carto@^8.8.0/dist.min.js"></script>
    <style>
      #map {
        height: 100%;
      }

      html,
      body {
        height: 100%;
        margin: 0;
        padding: 0;
      }
    </style>
  </head>

  <body>
    
    <div id="map"></div>

    <script  
      src="https://maps.googleapis.com/maps/api/js?key=AIzaSyDvHtBZM79O5uGTBT1ZOWOKW2_FVMstHNs&callback=initMap&libraries=&v=beta"
      async
    ></script>

  </body>

  <script type="text/javascript">
    let map;

    function initMap() {
      map = new google.maps.Map(document.getElementById("map"), {
        center: { lat: 40.7368521, lng: -73.9936065 },
        zoom: 12,
        tilt: 70,
        mapId: '74fb72d0338f9316',
        fullscreenControl: false,
        streetViewControl: false,
        zoomControlOptions: {
          position: google.maps.ControlPosition.LEFT_BOTTOM,
        },
      });

      deck.carto.setDefaultCredentials({
        username: "public",
        apiKey: "8l-WraD-0s4A5FJj9W7uIg",
        apiVersion: deck.carto.API_VERSIONS.V2,
      });

      const POLYGON_COLORS = [
        [128, 0, 32],
        [190, 1, 31],
        [255, 77, 32],
        [255, 142, 54],
        [255, 179, 66],
        [254, 239, 157],
        [253, 255, 208],
      ];

      const deckOverlay = new deck.GoogleMapsOverlay({
        layers: [
          new deck.carto.CartoLayer({
            id: 'mrli',
            type: deck.carto.MAP_TYPES.QUERY,
            data: `SELECT geoid, the_geom_webmercator, avg(txn_amt) as index
            FROM public.mrli_ny_jan WHERE industry ='ret'
            group by geoid, the_geom_webmercator`,
            getFillColor: deck.carto.colorBins({
              attr: 'index',
              domain: [0, 50, 150, 300, 600, 1000],
              colors: POLYGON_COLORS
            }),
            getLineColor: [0, 0, 0, 0],
            lineWidthMinPixels: 0,
            filled: true,
            extruded: true,
            wireframe: true,
            getElevation: (f) => {
              return f.properties.index ? f.properties.index : 0
            }
          }),
        ]
      });

      deckOverlay.setMap(map);
    }

  </script>
</html>
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.carto.com/carto-for-developers/key-concepts/carto-for-deck.gl/basemaps/carto-google-maps/readme-1/advanced-examples/extrusion.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
